<?php
namespace Pinpoint\TestimonialManager\Controller\Adminhtml\Areas;

use Magento\Backend\App\Action;

/**
 * Class Delete
 * @package Pinpoint\TestimonialManager\Controller\Adminhtml\Areas
 */
class Delete extends \Magento\Backend\App\Action
{
    /**
     * @var string
     */
    const ADMIN_RESOURCE = 'Pinpoint_TestimonialManager::addedit';

    /**
     * @var \Pinpoint\TestimonialManager\Model\TestimonialArea
     */
    protected $testimonialArea;

    /**
     * Delete constructor.
     * @param Action\Context $context
     * @param \Pinpoint\TestimonialManager\Model\TestimonialArea $testimonialArea
     */
    public function __construct(
        Action\Context $context,
        \Pinpoint\TestimonialManager\Model\TestimonialArea $testimonialArea
    ) {
        $this->testimonialArea = $testimonialArea;
        parent::__construct($context);
    }

    /**
     * @return \Magento\Backend\Model\View\Result\Redirect
     */
    public function execute()
    {
        // check if we know what should be deleted
        $id = $this->getRequest()->getParam('id');
        /** @var \Magento\Backend\Model\View\Result\Redirect $resultRedirect */
        $resultRedirect = $this->resultRedirectFactory->create();
        if ($id) {
            try {
                // init model and delete
                $model = $this->testimonialArea;
                $model->load($id);
                $model->delete();
                // display success message
                $this->messageManager->addSuccess(__('You have deleted the area.'));
                // go to grid
                return $resultRedirect->setPath('*/*/');
            } catch (\Exception $e) {
                // display error message
                $this->messageManager->addError($e->getMessage());
                // go back to edit form
                return $resultRedirect->setPath('*/*/edit', ['id' => $id]);
            }
        }
        // display error message
        $this->messageManager->addError(__('We can not find the area to delete.'));
        // go to grid
        return $resultRedirect->setPath('*/*/');
    }    
    
}
